//wqpnu: complex rational class etc.

//#include <vcl.h>
//#include <iostream>
#include "wqpnu.h"

void floerr()//e.g. for testing catch
{
	double x = 1;
	for (; ; )
		x*= 1000;
}


bool int_overflow;
//global for better performance
//must be set to false before checked_imult and checked_iadd
//true after overflow in checked_imult and checked_iadd:

int checked_iadd(int a, int b)
{
	if (a > 0)
	{
		if (b > 0)
		{
			if (a > nu_max_int - b)
			{
				int_overflow = true;
				return 1;
			}
			else
				return a + b;
		}
	}
	else //a<=0
	if (b < 0)
		if (a < nu_min_int - b)
		{
			int_overflow = true;
			return 1;
		}
	//      else
	return a + b;
}


int checked_imult(int a, int b)
{
	if (a > 0)
	{
		if (b > 0)
		{
			if (a > nu_max_int/b)
			{
				int_overflow = true;
				return 1;
			}
			else
				return a*b;
		} else //a>0, b<=0
		{
			if (b < (nu_min_int)/a)
			{
				int_overflow = true;
				return 1;
			}
			else
				return a*b;
		}
	}
	else //a<=0
	if (b > 0)
	{
		if (a < (nu_min_int)/b)
		{
			int_overflow = true;
			return 1;
		}
		else
			return a*b;
	} else //a<=0, b<=0
	{
		if (b == 0)
			return 0;
		else
			if (a < nu_max_int/b)
			{
				int_overflow = true;
				return 1;
			}
		//          else
		//              return a*b;
	}
	return a*b;
}


//ggt=groesster gemeinsamer Teiler
int ggt(int a, int b)
	//overflow not possible
{
	int zero(0);
	
	if (a < zero) a = - a;
	if (b < zero) b = - b;
	
	for(; ; ) {
		if(b == zero)
			return a;
		a %= b;
		if(a == zero)
			return b;
		b %= a;
	}
}



namespace {
	struct check_ratyp
	{
		check_ratyp(){
			if (nu_min_int >= 0)
				throw Exception ("nu_min_int<0 necessary"); }
	};
	check_ratyp check_ratyp_dummy; //zum Aufruf des Konstruktors, welcher Check durchfuert
}

class ratyp_error : public std::domain_error
{
	public:
	explicit ratyp_error() :
	std::domain_error("ratyp error: de=0") {}
};

//rational class: ratyp        ***************************
ratyp& ratyp::operator += (const ratyp& r)
	//for all operators: if only one operand is double, result
	//always is double (i.e. approximative result)
{
	if (isra)
	{
		if (r.isra)
		{
			int r_nu = r.nu;
			int r_de = r.de;
			
			int thisnu = nu; //necessary in case of overflow
			int thisde = de; //necessary in case of overflow
			
			int g = ggt(de, r_de);
			de /= g;
			
			//nu = nu * (r_de / g) + r_nu * de;
			//g = ggt(nu,g);
			//nu /= g;
			//de *= r_de/g;
			
			//above 4 comment lines in checking mode:
			int_overflow = false;
			nu = checked_iadd(
			checked_imult(nu, (r_de/g)),
			checked_imult(r_nu, de));
			g = ggt(nu, g);
			//ggt(nu,g) instead of ggt(nu,r_nu*nu/g) sufficient
			//idea of Nickolay Mladenov / Paul Moore
			nu/= g;
			de = checked_imult(de, r_de/g);
			if (int_overflow)
			{
				isra = false;
				qo = (double(thisnu)/double(thisde)) + (double(r_nu)/double(r_de));
			}
		}
		else //isra, not r.isra
		{
			isra = false;
			qo = double(nu)/double(de) + r.qo;
		}
	}
	else //not isra
	if (r.isra)
		qo += double(r.nu)/double(r.de);
	else
		qo += r.qo;
	
	return *this;
}

ratyp& ratyp::operator -= (const ratyp& r)
{
	if (isra)
	{
		if (r.isra)
		{
			int r_nu = r.nu;
			int r_de = r.de;
			int thisnu = nu;
			int thisde = de;
			
			int g = ggt(de, r_de);
			de /= g;
			
			int_overflow = false;
			nu = checked_iadd(
			checked_imult(nu, (r_de/g)),
			- checked_imult(r_nu, de)); //sign -
			
			g = ggt(nu, g);
			nu/= g;
			de = checked_imult(de, r_de/g);
			if (int_overflow)
			{
				isra = false;
				qo = (double(thisnu)/double(thisde)) - (double(r_nu)/double(r_de));
			}
		}
		else //isra, not r.isra
		{
			isra = false;
			qo = double(nu)/double(de) - r.qo;
		}
	}
	else //not isra
	if (r.isra)
		qo -= double(r.nu)/double(r.de);
	else
		qo -= r.qo;
	return *this;
}

ratyp& ratyp::operator*= (const ratyp& r)
{
	if (isra)
	{
		if (r.isra)
		{
			int r_nu = r.nu;
			int r_de = r.de;
			int thisnu = nu;
			int thisde = de;
			
			int ggt1 = ggt(nu, r_de);
			int ggt2 = ggt(r_nu, de);
			
			int_overflow = false;
			nu = checked_imult((nu/ggt1), (r_nu/ggt2));
			de = checked_imult((de/ggt2), (r_de/ggt1));
			if (int_overflow)
			{
				isra = false;
				qo = (double(thisnu)/double(thisde)) * (double(r_nu)/double(r_de));
			}
		}
		else //isra, not r.isra
		{
			isra = false;
			qo = (double(nu)/double(de)) * r.qo;
		}
	}
	else //not isra
	if (r.isra)
		qo*= (double(r.nu)/double(r.de));
	else
		qo*= r.qo;
	return *this;
}

ratyp& ratyp::operator/= (const ratyp& r)
{
	if (isra)
	{
		if (r.isra)
		{
			
			int r_nu = r.nu;
			int r_de = r.de;
			int thisnu = nu;
			int thisde = de;
			
			int zero(0);
			
			if (r_nu == zero)
				throw ratyp_error();
			if (nu == zero)
				return *this;
			
			int ggt1 = ggt(nu, r_nu);
			int ggt2 = ggt(r_de, de);
			
			int_overflow = false;
			nu = checked_imult((nu/ggt1), (r_de/ggt2));
			de = checked_imult((de/ggt2), (r_nu/ggt1));
			if (int_overflow)
			{
				isra = false;
				qo = (double(thisnu)/double(thisde)) / (double(r_nu)/double(r_de));
			}
			
			if (de < zero) {
				nu = - nu;
				de = - de;
			}
		}
		else //isra, not r.isra
		{
			isra = false;
			qo = (double(nu)/double(de)) / r.qo;
		}
	}
	else //not isra
	if (r.isra)
		qo/= (double(r.nu)/double(r.de));
	else
		qo/= r.qo;
	return *this;
}


const ratyp& ratyp::operator++()
{if (isra)
	{
		int_overflow = false;
		int thisnu = nu;
		nu = checked_iadd(nu, de);
		if (int_overflow)
		{
			isra = false;
			qo = double(thisnu)/double(de) + 1.0;
		}
	}
	else ++qo;
	return *this;
}

const ratyp& ratyp::operator--()
{if (isra)
	{
		int_overflow = false;
		int thisnu = nu;
		nu = checked_iadd(nu, - de);
		if (int_overflow)
		{
			isra = false;
			qo = double(thisnu)/double(de) - 1.0;
		}
	}
	else --qo;
	return *this;
}

const ratyp ratyp::operator++(int)
{
	ratyp tmp(*this);
	++(*this);
	return tmp;
}

const ratyp ratyp::operator--(int)
{
	ratyp tmp(*this);
	--(*this);
	return tmp;
}

bool ratyp::operator < (const ratyp& r) const
{
	if (isra)
	{
		if (r.isra)
		{
			int zero(0);
			if (nu < zero && r.nu >= zero)  return true;
			if (nu >= zero && r.nu <= zero) return false; //because de>0
			
			int ggt1 = ggt(nu, r.nu);
			int ggt2 = ggt(r.de, de);
			
			int_overflow = false;
			int a = checked_imult(nu/ggt1, r.de/ggt2);
			int b = checked_imult(de/ggt2, r.nu/ggt1);
			if (int_overflow)
				return (double(nu)/double(de)) < (double(r.nu)/double(r.de));
			else
				return a < b;
		}
		else //isra, not r.isra
		return double(nu)/double(de) < r.qo;
	}
	else //not isra
	if (r.isra)
		return qo < double(r.nu)/double(r.de);
	else
		return qo < r.qo;
}

bool ratyp::operator < (const double& x) const
{
	if (isra)
		return (double(nu)/double(de) < x);
	else
		return qo < x;
}

bool ratyp::operator < (int i) const
{
	if (isra)
	{
		int zero(0);
		if (nu < zero && i >= zero) return true;
		if (nu >= zero && i <= zero) return false;
		if (nu > zero)
			return (double(nu)/double(de)) < i;
		else
			return - i < (- double(nu)/double(de));
	}
	else //not isra
	return qo < double(i);
}

bool ratyp::operator == (const ratyp& r) const
{
	if (isra)
	{
		if (r.isra)
		{
			return ((nu == r.nu) && (de == r.de));
		}
		else //isra, not r.isra
		return double(nu)/double(de) == r.qo;
	}
	else //not isra
	if (r.isra)
		return double(r.nu)/double(r.de) == qo;
	else
		return qo == r.qo;
}


bool ratyp::operator > (const ratyp& r) const
{
	if (isra)
	{
		if (r.isra)
		{
			int zero(0);
			if (nu >= zero && r.nu < zero)  return true;
			if (nu <= zero && r.nu >= zero) return false; //because de>0
			
			int ggt1 = ggt(nu, r.nu);
			int ggt2 = ggt(r.de, de);
			
			int_overflow = false;
			int a = checked_imult(nu/ggt1, r.de/ggt2);
			int b = checked_imult(de/ggt2, r.nu/ggt1);
			if (int_overflow)
				return (double(nu)/double(de)) > (double(r.nu)/double(r.de));
			else
				return a > b;
		}
		else //isra, not r.isra
		return double(nu)/double(de) > r.qo;
	}
	else //not isra
	if (r.isra)
		return qo > double(r.nu)/double(r.de);
	else
		return qo > r.qo;
}

bool ratyp::operator > (const double& x) const
{
	if (isra)
		return (double(nu)/double(de) > x);
	else
		return qo > x;
}

bool ratyp::operator > (int i) const
{
	if (isra)
	{
		int zero(0);
		if (nu >= zero && i < zero) return true;
		if (nu <= zero && i >= zero) return false;
		if (nu > zero)
			return (double(nu)/double(de)) > i;
		else
			return - i > (- double(nu)/double(de));
	}
	else //not isra
	return qo > double(i);
}

//----------------------------
void ratyp::shorten()
{
	int zero(0);
	if (de == zero)
		throw ratyp_error();
	
	// Handle the case of zero separately, to avoid division by zero
	if (nu == zero)
	{de = int(1); return; }
	
	int g = ggt(nu, de);
	nu /= g;
	de /= g;
	
	// Ensure that de is positive
	if (de < zero)
	{nu = - nu; de = - de; }
}


//kgv=kleinstes gemeinsames Vielfaches, not needed for ratyp
int kgv(int n, int m)
{
	int zero(0);
	
	if (n == zero || m == zero)
		return zero;
	
	n /= ggt(n, m);
	n *= m;
	
	if (n < zero)
		n = - n;
	return n;
}

//abs not needed for ratyp, slow implementation may be:
ratyp abs(const ratyp& r)
{
	if (r.israt())
	{
		if (r.num() >= int(0))
			return r;
		else
			return ratyp(- r.num(), r.den());
	}
	else
	{
		double q = r.quot();
		return q < 0 ? ratyp(- q):ratyp(q);
	}
}


//conversion to AnsiString

ratyp::operator AnsiString() const
{
	if (isra)
		return de == 1 ? AnsiString(nu) : AnsiString(nu) + "/" + AnsiString(de);
	else
		return AnsiString(qo);
};

AnsiString astr(int letters, const ratyp& r)
{
	AnsiString s=AnsiString(r);
	if (s.Length()<=letters+3)
		return s;
	else
	{
		if (r.israt())
			return FloatToStrF(double(r.num())/double(r.den()),
			ffGeneral, letters, letters);
		else
			return FloatToStrF(r.quot(), ffGeneral, letters, letters);
	}
}

bool ratyp::InputFromStr(const AnsiString& s)
{
	int p = s.Pos("/");
	
	if (p)
	{
		int len = s.Length();
		if (len == p)
			return false;
		else
		{
			isra = true;
			if (TryStrToInt(s.SubString(1, p - 1), nu)
			&& TryStrToInt(s.SubString(p + 1, len - p), de))
			{
				if (de)
				{
					shorten();
					return true;
				}
				else //  if de == 0, i.e. nu/0
				return false;
			}
			else
				return false;
		}
	}
	else
	{
		if (TryStrToInt(s, nu))
		{
			de = 1;
			isra = true;
			return true;
		}
		else
		{
			isra = false;
			return TryStrToFloat(s, qo);
		}
	}
}


//class cotyp; complex type which uses ratyp ***************************

cotyp& cotyp::operator += (const cotyp& c)
{ re+= c.re; im += c.im; return *this; }

cotyp& cotyp::operator -= (const cotyp& c)
{ re-= c.re; im -= c.im; return *this; }

cotyp& cotyp::operator*= (const cotyp& c)
{
	ratyp r = re * c.re - im * c.im;
	//im = re * c.im + im * c.re;
	im*= c.re;
	im += re * c.im;
	re = r;
	return *this;
}

cotyp& cotyp::operator/= (const cotyp& c)
{
	ratyp codeno = c.re*c.re + c.im*c.im;
	ratyp r = (re*c.re + im*c.im) / codeno;
	im = (im*c.re- re*c.im) / codeno;
	re = r;
	return *this;
}

//--------
cotyp::operator AnsiString() const
{
	if (im != 0)
	{
		if (re != 0)
		{
			if (im < 0)
				return AnsiString(re) + AnsiString(im) + "i";
			else
				return AnsiString(re) + "+" + AnsiString(im) + "i";
		}
		else
			return AnsiString(im) + "i";
	}
	else
		return AnsiString(re);
};

AnsiString astr(int letters, const cotyp& c)
{
	AnsiString s=AnsiString(c);
	if (s.Length()<=letters+3)
		return s;
	else
	{
		int l2=letters/2;
		if (c.imag() != 0)
		{
			if (c.real() != 0)
			{
				if (c.imag() < 0)
					return astr(l2, c.real()) + astr(l2, c.imag()) + "i";
				else
					return astr(l2, c.real()) + "+" + astr(l2, c.imag()) + "i";
			}
			else
				return astr(l2, c.imag()) + "i";
		}
		else
			return astr(l2, c.real());
	}
}

//Rueckgabe true, falls ok
bool cotyp::InputFromStr(const AnsiString& s_org)
{
	AnsiString s = s_org.Trim(); //s=s_org without leading and trailing spaces
	int ipos = s.Pos("i");
	if (ipos)
	{
		if (ipos != s.Length())
			return false; //trailing spaces deleted, so i must be last char
		
		//the following block due to convenience to allow i instead of 1i
		if (ipos>1)
		{if (s[ipos-1]=='+' || s[ipos-1]=='-')
				s.Insert("1",ipos++);}		else//if ipos==1
		s.Insert("1",ipos++);
		
		int itrenn = (s[1]  == '+' || s[1]  == '-') ? 2:1; //skip first sign
		
		while (s[itrenn]!='+' && s[itrenn]!='-')
		{
			if (s[itrenn] == 'E' || s[itrenn] == 'e') ++itrenn; //skip sign of exponent
			if (itrenn < ipos) ++itrenn; else break;
		}
		
		if (itrenn == ipos)//no +- in between
		{
			re = 0;
			return im.InputFromStr(s.SubString(1, ipos - 1));
		}
		else
		{
			return re.InputFromStr(s.SubString(1, itrenn - 1))
				&& im.InputFromStr(s.SubString(itrenn, ipos - itrenn));
		}
	}
	else
	{
		im = 0;
		return re.InputFromStr(s);
	}
}

//--------

ratyp abs2(const cotyp& c)
{return c.real()*c.real() + c.imag()*c.imag(); }

//   #include <math.h>
//   double abs(const cotyp& c)
//   {return sqrt(double( c.real()*c.real() + c.imag()*c.imag() )) ; }



