//not only header:
//contains components of TF1 F1
//include this file once after wutil1.h and definition of F1

//needs F1->Slconfig
//needs F1->ProgressBar1, F1->ShowProgressGroupbox if wutilbc_without_probar not defined

//begin break ---------------------------------------------------------------------------
struct bkc{ //breakclass
	static bool break_pressed;
	
	bkc(bool make_at_once_visible);
	~bkc() {RemoveBreakGroupBox();}
	bool breaksignaled();
	void RemoveBreakGroupBox()
	{F1->BreakGroupBox->Visible=false;
		F1->Repaint();
	}
};

bool bkc::break_pressed;

bkc::bkc(bool make_at_once_visible=true)
{
	break_pressed=false;
	if (make_at_once_visible && !F1->BreakGroupBox->Visible)
		F1->BreakGroupBox->Visible=true;
	F1->Repaint();
}

bool bkc::breaksignaled()
{
	Application->ProcessMessages();
	if (break_pressed)
	{
		//		break_pressed=false;
		return true;
	}
	else
	{
		if (!F1->BreakGroupBox->Visible)
			F1->BreakGroupBox->Visible=true;
		return false;
	}
}

void __fastcall TF1::BreakButtonClick(TObject *Sender)
{bkc::break_pressed=true; F1->BreakGroupBox->Visible=false;}
//ende break ---------------------------------------------------------------------------


bool GetFnFromOpenDialog_1(AS &fnget, const AS& title, const AS& FileEndFilter)
	//return true, if fnget valid
{
	F1->OpenDialog1->Title = title;
	//    F1->OpenDialog1->DefaultExt = FileEnd;
	F1->OpenDialog1->Options << ofFileMustExist;
	F1->OpenDialog1->Filter = FileEndFilter;
	F1->OpenDialog1->FileName = fnget;
	if (F1->OpenDialog1->Execute())
	{
		fnget = LowStrAfterLast(F1->OpenDialog1->FileName, "\\");
		return true;
	}
	else return false;
}

//---------------------------------------------------------------------------

bool GetSaveFn_1(AS& fnsave)
{
	AS  FileEndDefault=fn_end(fnsave);
	F1->SaveDialog1->DefaultExt = FileEndDefault;
	F1->SaveDialog1->Filter = FileEndDefault +
	" files (*." + FileEndDefault + ")|*." + FileEndDefault;
	F1->SaveDialog1->FileName = fnsave;
	//F1->SaveDialog1->Options << ofOverwritePrompt;
	bool do_save = F1->SaveDialog1->Execute();
	if (do_save)
	{
		//        fnsave=FnWithEnd(F1->SaveDialog1->FileName, FileEndDefault);
		fnsave = LowStrAfterLast(F1->SaveDialog1->FileName, "\\");
	}
	return do_save;
}
//-------
//-----begin cphclasseaderclass: cpar_header
//         F1->Slconfig must be defined

const char char_comment='\"';//Comment line for edit tabsheet
enum {islc_nr, islc_default, islc_key,islc_description,islc_i};

class cphclass
{
	int LastMouseX;//for mousemove-update of Slconfig
	int LastMouseY;
	
	protected:
	bool reject_ikuk_reinit;
	
	public:
	Kmap kmap;
	const AS entry_date;
	const char char_skipline; //ignore line
	bool FirstPassBeforeCfgUpdate;
	bool Slconfig_uptodate;
	
	int kmi(const AS& skey) const; //return kmi(skey) with check
	
	cphclass();
	void CphInitAfterAllCpIkUkpairInit();
	void setkmi_1(const AS& skey, int i); //set kmi(skey) with check
	void UpdateSlconfigFromcph();
	
	void Ikpair(
	const AS &first,
	const int &i, //value
	const AS &description = NullString,
	const int &min = intmin,
	const int &max = intmax);
	
	void Ukpair(//for entries which are changed by config read
	const AS &first,
	const int &i, //value
	const AS &description = NullString,
	const int &min = intmin,
	const int &max = intmax);
	
	void CorrectAndUpdateSlconfigCellOnXYChange(int MouseX, int MouseY);
	void UpdateSlconfigCellFromcph () const;
	void CorrectSlconfigCellOrUpdatecph ();
	AS TryToReadConfigEntry_1(AS& s, const AS& skey, bool read_all);
	void SetScreenConfiguration();
	void GetScreenConfiguration();
	void SaveCpToOut(ofstream &out) const;
	void OnSlconfigKeyPress(char &Key);
	virtual void DothisAfterCfgUpdate()=0;
};
//---
//not SlUpd because this would need pointer to elementfunction as parameter, so:
void cphclass::CorrectAndUpdateSlconfigCellOnXYChange(int MouseX, int MouseY)
{
	if (Slconfig_uptodate ||
	(LastMouseX == MouseX &&
	LastMouseY == MouseY))
	return;
	LastMouseX = MouseX;
	LastMouseY = MouseY;
	CorrectSlconfigCellOrUpdatecph();
}
//---

cphclass::cphclass():
char_skipline(';'),
entry_date("e_dt"),
FirstPassBeforeCfgUpdate(false),
LastMouseX(0), LastMouseY(0), Slconfig_uptodate(false),
reject_ikuk_reinit(true)
{}

void cphclass::SetScreenConfiguration()
{
	F1->Height=kmi("F1_Screen_Default_Height");
	F1->Width=kmi("F1_Screen_Default_Width");
	F1->Top=kmi("F1_Screen_Default_Top");
	F1->Left=kmi("F1_Screen_Default_Left");
}

void cphclass::GetScreenConfiguration()
{
	setkmi_1("F1_Screen_Default_Height",F1->Height);
	setkmi_1("F1_Screen_Default_Width",F1->Width);
	setkmi_1("F1_Screen_Default_Top",F1->Top);
	setkmi_1("F1_Screen_Default_Left",F1->Left);
}

int cphclass::kmi(const AS& skey) const
{
	const_Kmapi it = kmap.find(skey);
	if (it == kmap.end())
	{
		pip ("kmi:\n   " + skey + "\nis no valid keyword,\n"
		"perhaps wrong typing in source.\n"
		"0 returned");
		return 0;
	}
	else
		return it->second.i;
}

void cphclass::setkmi_1(const AS& skey, int ineu)
{
	Kmapi it = kmap.find(skey);
	if (it == kmap.end())
	{
		pip ("setkmi_1:\n   " + skey + "\nis no valid keyword,\n"
		"perhaps wrong typing in source.\n"
		" kmi is not set");
	}
	else
	{
		if (ineu<it->second.min || ineu>it->second.max)
			pip ("setkmi_1:\n   " + skey + "\ninput i="+AS(ineu)+"\n"
			"out of range ["
			+AS(it->second.min)+".."+AS(it->second.max)+"]\n"
			" kmi is not set");
		else
			it->second.i = ineu;
	}
}
AS cphclass::TryToReadConfigEntry_1(AS& s, const AS& skey, bool read_all)
	//test for "" keyword
{
	Kmapi it = kmap.find(skey);
	if (it == kmap.end())
	{
		#if 0
		pip ("Info\n" + skey + "    is no valid keyword,\n"
		"perhaps due to old format of input file.\n"
		"Input line is ignored");
		F1->Repaint();
		#endif
		return NullString;
	}
	
	if (read_all || it->second.ucfg)
	{
		int i, min, max;
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), i))
			return skey + ": i is no int";
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), min))
			return skey + ": min is no int";
		if (!TryStrToInt(CutTillSpaceOrEnd_1(s), max))
			return skey + ": max is no int";
		//if (!s.IsEmpty()) return skey + seol;//not, because of ucfg
		
		if (i < min)
			return skey + " i = " + IntToStr(i) + " < " + IntToStr(min) + " = min";
		if (i > max)
			return skey + " i = " + IntToStr(i) + " > " + IntToStr(max) + " = max";
		
		it->second.i = i;
		//read not minmax, because code can change: //it->second.min = min; it->second.max = max;
	}
	return NullString;
}

void cphclass::CphInitAfterAllCpIkUkpairInit()
	//call it after all other Ukpair or Ikpair calls
	//because here size of slconfig is determined
{
	Ukpair("F1_Screen_Default_Height", F1->Height,
	"screen configuration (pixel values)");
	Ukpair("F1_Screen_Default_Width", F1->Width,
	"screen configuration (pixel values)");
	Ukpair("F1_Screen_Default_Top",  F1->Top,
	"screen configuration (pixel values)");
	Ukpair("F1_Screen_Default_Left",  F1->Left,
	"screen configuration (pixel values)");
	
	//void cphclass::InitFixedSlconfig() const
	{
		F1->Slconfig->RowCount = kmap.size() + 1;//therefore AFTER all UkIkpairInit
		F1->Slconfig->Cells[islc_nr][0] = "row";
		F1->Slconfig->Cells[islc_default][0] = "r";
		F1->Slconfig->Cells[islc_key][0] = "          keyword";
		F1->Slconfig->Cells[islc_description][0] = "          description";
		F1->Slconfig->Cells[islc_i][0] = "     i";
	}
}

void cphclass::UpdateSlconfigFromcph()
{
	GetScreenConfiguration();
	Kmapi it;
	int j;
	for (j = 1, it = kmap.begin(); it != kmap.end(); ++it, ++j)
	{
		F1->Slconfig->Cells[islc_nr][j] = AS(j);
		F1->Slconfig->Cells[islc_default][j]
		= it->second.ucfg?AS("u"):NullString;
		F1->Slconfig->Cells[islc_key][j] = it->first;
		F1->Slconfig->Cells[islc_description][j] =
		FullDescriptionFromMappedKeyVal(it->second);
		F1->Slconfig->Cells[islc_i][j] = AS(it->second.i);
	}
	Slconfig_uptodate = true;
}
//define_individual_kpair
void cphclass::Ikpair(const AS &first, const int& i,
const AS& description,
const int& min, const int& max)
{
	if (reject_ikuk_reinit)
	{
		Kmapi it = kmap.find(first);
		if (it != kmap.end())
		{pip (first+"\n already defined, new definition"
			+"\n by Ikpair ignored"); return;}
	}
	if (i > max || i < min)
		pipex(first + " wrong initialized");
	
	Kpair kp;
	kp.first = first;
	kp.second.description = description;
	kp.second.i = i;
	kp.second.min = min;
	kp.second.max = max;
	kp.second.ucfg = false;
	
	kmap[kp.first] = kp.second;
}

//define_uniform_kpair
void cphclass::Ukpair(const AS& first, const int& i,
const AS& description,
const int& min, const int& max)
//same as Ikpair, but ucfg=true
{
	if (reject_ikuk_reinit)
	{
		Kmapi it = kmap.find(first);
		if (it != kmap.end())
		{pip (first+"\n already defined, new definition"
			+"\n by Ukpair ignored"); return;}
	}
	
	if (i > max || i < min)
		pipex(first + " wrong initialized");
	
	Kpair kp;
	kp.first = first;
	kp.second.description = description;
	kp.second.i = i;
	kp.second.min = min;
	kp.second.max = max;
	kp.second.ucfg = true;
	
	kmap[kp.first] = kp.second;
}

void cphclass::UpdateSlconfigCellFromcph () const
{
	const_Kmapi it = kmap.find(F1->Slconfig->Cells[islc_key][F1->Slconfig->Row]); //get keyword
	
	#ifdef wdebug
	if (it == kmap.end())
	{
		pip ("UpdateSlconfigCellFromcph:\n"
		"Keyword not found in kmap");
		return;
	}
	#endif
	
	F1->Slconfig->Cells[islc_description][F1->Slconfig->Row] =
	FullDescriptionFromMappedKeyVal(it->second);
	F1->Slconfig->Cells[islc_i][F1->Slconfig->Row] = AS(it->second.i);
}


void cphclass::CorrectSlconfigCellOrUpdatecph()
{
	Kmapi it = kmap.find(F1->Slconfig->Cells[islc_key][F1->Slconfig->Row]);
	
	#ifdef wdebug
	if (it == kmap.end())
	{
		pip ("CorrectSlconfigCellOrUpdatecph:\n"
		"Keyword not found in kmap");
		return;
	}
	#endif
	
	int k;
	if (TryStrToInt (F1->Slconfig->Cells[islc_i][F1->Slconfig->Row], k))
	{
		if (k > it->second.max)
		{
			it->second.i = it->second.max;
			Beep();
		}
		else
			if (k < it->second.min)
			{
				it->second.i = it->second.min;
				Beep();
			}
			else //if between min..max
			it->second.i = k;
	}
	else
		Beep();
	
	UpdateSlconfigCellFromcph();
	DothisAfterCfgUpdate();
	Slconfig_uptodate = true;
}

void cphclass::SaveCpToOut(ofstream &out) const
{
	//write slconfig:
	out << endl;
	out << char_skipline << "the following lines contain several program parameters" << endl;
	out << char_skipline << "in the order: keyword i min max ucfg" << endl;
	for (const_Kmapi it = kmap.begin(); it != kmap.end(); ++it)
		out << it->first
		<< aspace << it->second.i
		<< aspace << it->second.min
		<< aspace << it->second.max
		<< aspace << it->second.ucfg
		<< endl;
	out << endl;
}

void cphclass::OnSlconfigKeyPress(char &Key)
{
	if (NoTextChangeKeys.Pos(Key) == 0)//if TextChangeKey
	Slconfig_uptodate = false;
	
	char c = UpCase(Key);
	
	if (intRegularInput.Pos(c))
		return;
	
	switch (c)
	{
		case '\r': break;
		case 'P':
		case 'M':
			{
				int add = (c  == 'P') ? 1: - 1;
				F1->Slconfig->Cells[F1->Slconfig->Col][F1->Slconfig->Row] = AS
				(StrToInt(F1->Slconfig->Cells[F1->Slconfig->Col][F1->Slconfig->Row]) + add);
			}
			break;
		default:
			Beep();
			break;
	}
	Key = 0;
	CorrectSlconfigCellOrUpdatecph ();
}
//-----end cphclass

class SlUpd//for mousemove-update of Sl
{
	int LastMouseX;
	int LastMouseY;
	
	public:
	bool uptodate;
	void CorrectAndUpdateSlCellOnXYChange(
	int MouseX, int MouseY, void SlUpdFunc());
	SlUpd():LastMouseX(0), LastMouseY(0), uptodate(false) {};
};

void SlUpd::CorrectAndUpdateSlCellOnXYChange(
int MouseX, int MouseY, void SlUpdFunc())
{
	if (uptodate ||
	(LastMouseX == MouseX &&
	LastMouseY == MouseY))
	return;
	LastMouseX = MouseX;
	LastMouseY = MouseY;
	SlUpdFunc();//should update sl
	uptodate=true;
}

//----------------
#ifndef wutilbc_without_probar
struct probar{
	
	void SetProgressBarPosition(int pos)
	{F1->ProgressBar1->Position = pos;}
	
	void init(int min, int max, const AS &pcaption);
	probar(){}
	probar(int min, int max, const AS &pcaption=" Progress")
	{init(min, max, pcaption);}
	void RemoveProgressBar() {F1->ShowProgressGroupbox->Visible = false;}
	~probar(){RemoveProgressBar();}
};
void probar::init(int min, int max, const AS &pcaption=" Progress")
{
	F1->ProgressBar1->Max = intmax;
	F1->ProgressBar1->Min = intmin;//that next assignments surely in allowed range
	F1->ProgressBar1->Max = max;
	F1->ProgressBar1->Min = min;
	SetProgressBarPosition(min);
	F1->ShowProgressGroupbox->Visible = true;
	F1->ShowProgressGroupbox->Caption=pcaption;
	F1->ShowProgressGroupbox->Repaint();
}
#endif //of #ifndef wutilbc_without_probar
//-----------

